PRO orfeo_orthorectificationfilter, ev

  	; Select an input file :
	fileIN = ENVI_PICKFILE(TITLE = "Select an input file")
	IF fileIN EQ '' THEN $
		MESSAGE, "You must select an input file"
	ENVI_OPEN_FILE, fileIN, R_FID = fid

	ENVI_FILE_QUERY, fid, NB = nb
	ENVI_DISPLAY_BANDS, REPLICATE(fid, nb), INDGEN(nb)

	fileOut = ENVI_PICKFILE(TITLE = "Select an output file")
	IF fileOUT EQ '' THEN $
		MESSAGE, "You must select an output file"


	tlb = WIDGET_AUTO_BASE(title = 'Ortho Rectification filter parameters')

	p1 = WIDGET_PARAM(TLB, /AUTO_MANAGE, DT = 10, FIELD = 2, $
   	PROMPT = 'UTM Zone:', UVALUE = 'UtmZone', DEFAULT = 31)
	p2 = WIDGET_STRING(TLB, PROMPT = 'Hemisphere:', UVALUE = 'Hemisphere', /auto, DEFAULT = 'N')
	p3 = WIDGET_STRING(TLB, PROMPT = 'X Ground UL:', UVALUE = 'XGroundUL', /auto, DEFAULT = '375000')
	p4 = WIDGET_STRING(TLB, PROMPT = 'Y Ground UL:', UVALUE = 'YGroundUL', /auto, DEFAULT = '4828100')
	p5 = WIDGET_PARAM(TLB, /AUTO_MANAGE, DT = 12, FIELD = 100, $
   	PROMPT = 'X Size:', UVALUE = 'XSize', DEFAULT = 500)
   	p6 = WIDGET_PARAM(TLB, /AUTO_MANAGE, DT = 12, FIELD = 100, $
	PROMPT = 'Y Size:', UVALUE = 'YSize', DEFAULT = 500)
   	p7 = WIDGET_PARAM(TLB, /AUTO_MANAGE, DT = 10, FIELD = 2, $
   	PROMPT = 'X ground Sampling:', UVALUE = 'XGroundSampling', DEFAULT = 0.6)
   	p8 = WIDGET_PARAM(TLB, /AUTO_MANAGE, DT = 10, FIELD = 2, $
   	PROMPT = 'Y ground Sampling:', UVALUE = 'YGroundSampling', DEFAULT = -0.6)

   	res = AUTO_WID_MNG(TLB)

	; Default values :
	IF res.accept EQ 0 THEN BEGIN
		res.UtmZone = 31.
		res.Hemisphere = "N"
		res.XGroundUL = 375000
		res.YGroundUL = 4828100
		res.XSSSize = 500
		res.YSSSize = 500
		res.XGroundSampling = 0.6
		res.YGroundSampling = -0.6
	END


	OTBORTHORECTIFICATION, fileIn, fileOut, $
	res.UtmZone , res.Hemisphere , res.XGroundUL , res.YGroundUL , $
	res.XSize , res.YSize , res.XGroundSampling , res.YGroundSampling 


	; Read image :
	imageOut = READ_IMAGE(fileOut)
	ENVI_OPEN_FILE, fileOut, R_FID = fidout
	ENVI_FILE_QUERY, fidout, NB = nbout
	ENVI_DISPLAY_BANDS, REPLICATE(fidout, nbout), INDGEN(nbout)
	ENVI_ENTER_DATA, imageOut

END
