; Event handler :
PRO simpleIDLGUI_event, ev

	; Error handler :
	err = 0
	CATCH, err
	IF err NE 0 THEN BEGIN

		res = DIALOG_MESSAGE(!error_state.msg, /ERROR)
		CATCH, /CANCEL
		RETURN

	END

	; Get state structure :
	WIDGET_CONTROL, ev.top, GET_UVALUE = pState

	; Get user value :
	WIDGET_CONTROL, ev.id, GET_UVALUE = uval

	CASE uval OF

		"browseinput": BEGIN

			strInputFile = DIALOG_PICKFILE()
			IF ~FILE_TEST(strInputFile) THEN $
				MESSAGE, "Invalid input filename"
			WIDGET_CONTROL, (*pState).wInputFile, SET_VALUE = strInputFile

		END

		"browseoutput": BEGIN

			strOutputFile = DIALOG_PICKFILE()
			WIDGET_CONTROL, (*pState).wOutputFile, SET_VALUE = strOutputFile

		END

		"OK": BEGIN

			; Get input filename :
			WIDGET_CONTROL, (*pState).wInputFile, GET_VALUE = strInputFile

			; Test it :
			IF ~FILE_TEST(strInputFile) THEN $
				MESSAGE, "Invalid input filename"

			; Store it :
			(*pState).strInputFile = strInputFile

			; Get output filename :
			WIDGET_CONTROL, (*pState).wOutputFile, GET_VALUE = strOutputFile
			(*pState).strOutputFile = strOutputFile

			; Test it :
			IF strOutputFile EQ '' THEN $
				MESSAGE, "Invalid output filename"

			; Store it :
			(*pState).strOutputFile = strOutputFile

			; Read radius :
			WIDGET_CONTROL, (*pState).wRadius, GET_VALUE = radius

			WIDGET_CONTROL, /HOURGLASS
			; Call TOUZI edge detector :
			OTBTOUZIEDGEDETECTOR, (*pState).strInputFile, (*pState).strOutputFile, $
			radius
			WIDGET_CONTROL, HOURGLASS = 0

			; Load files into ENVI :
			ENVI_OPEN_DATA_FILE, (*pState).strInputFile
			ENVI_OPEN_DATA_FILE, (*pState).strOutputFile

			; Destroy GUI :
			WIDGET_CONTROL, ev.top, /DESTROY

		END

		"Cancel": WIDGET_CONTROL, ev.top, /DESTROY

		ELSE:
	END

END

PRO simpleIDLGUICleanup, tlb

	WIDGET_CONTROL, tlb, GET_UVALUE = pState
	IF PTR_VALID(pState) THEN $
		PTR_FREE, pState

END

; GUI Definition :
PRO simpleIDLGUI, ev

	base = WIDGET_BASE(/COLUMN, TITLE = "Simple IDL GUI")

	; Input base :
	baseIn = WIDGET_BASE(base, /COLUMN, /FRAME)
	baseInput = WIDGET_BASE(baseIn, /ROW)
	wInputFile = CW_FIELD(baseInput, TITLE = "I/P :", UVALUE = "inputFile", /STRING, $
	XSIZE = 40)
	wInputButton = WIDGET_BUTTON(baseInput, VALUE = "Browse ...", UVALUE = "browseinput")

	; Ouput base :
	baseOut = WIDGET_BASE(base, /COLUMN, /FRAME)
	baseOutput = WIDGET_BASE(baseOut, /ROW)
	wOutputFile = CW_FIELD(baseOutput, TITLE = "O/P :", UVALUE = "outputFile", /STRING, $
	XSIZE = 40)
	wOutputButton = WIDGET_BUTTON(baseOutput, VALUE = "Browse ...", UVALUE = "browseoutput")

	; Epsilon base :
	baseEps = WIDGET_BASE(base, /COLUMN, /FRAME)
	baseEpsilon = WIDGET_BASE(baseEps, /ROW)
	wRadius = CW_FIELD(baseEpsilon, TITLE = "Radius", /INTEGER, VALUE = 3, $
	XSIZE = 1)

	; OK/Cancel base :
	okCancelBase = WIDGET_BASE(base, /ROW, /FRAME)
	wOK = WIDGET_BUTTON(okCancelBase, VALUE = "OK", UVALUE = "OK")
	wCancel = WIDGET_BUTTON(okCancelBase, VALUE = "Cancel", UVALUE = "Cancel")

	; State structure :
	st = {strInputFile: '', strOutputFile: '', radius: 0, $
	wInputFile: wInputFile, wOutputFile: wOutputFile, wRadius: wRadius}

	; Display :
	WIDGET_CONTROL, base, /REALIZE, SET_UVALUE = PTR_NEW(st, /NO_COPY)
	XMANAGER, "simpleIDLGUI", base

END